## kube-0.9.0-2.src.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(kube VERSION 0.9.0)

set(QT_MIN_VERSION 5.9.0)

cmake_policy(SET CMP0011 NEW)
cmake_policy(SET CMP0028 NEW)
cmake_policy(SET CMP0048 NEW)
cmake_policy(SET CMP0053 NEW)
cmake_policy(SET CMP0063 NEW)

option(EXPERIMENTAL_VIEWS "Install experimental views" OFF)
#Do not enable this unless you actually distribute a custom extension.
option(ENABLE_EXTENSIONS "Enable custom kube extensions" OFF)
set(AVAILABLE_ACCOUNT_PLUGINS "kolabnow" "fastmail" "gmail" "generic" CACHE STRING "List of enabled account plugins (provide as semicolon separated string)" )

include(CPack)
include(FeatureSummary)
find_package(PkgConfig REQUIRED)
find_package(ECM 5.29.0 REQUIRED NO_MODULE)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/ ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECompilerSettings)
#Avoid building appstreamtest
set(KDE_SKIP_TEST_SETTINGS true)
include(KDECMakeSettings NO_POLICY_SCOPE)
include(ECMSetupVersion)

kde_enable_exceptions()

# Get the current working branch
execute_process(
  COMMAND git rev-parse --abbrev-ref HEAD
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE GIT_BRANCH
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

# Get the latest abbreviated commit hash of the working branch
execute_process(
  COMMAND git log -1 --format=%h
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE GIT_COMMIT_HASH
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

ecm_setup_version(PROJECT SOVERSION kube_VERSION_MAJOR)
configure_file(kube_version.h.in ${CMAKE_BINARY_DIR}/kube_version.h)

enable_testing()

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
if (MSVC)
    # Workaround for older cmake versions
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /std:c++20")
    # We get way to many warnings for this
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-nonportable-include-path")
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
if (${EXPERIMENTAL_VIEWS})
    add_definitions(-DKUBE_EXPERIMENTAL)
endif()
add_subdirectory(framework)
add_subdirectory(components)
add_subdirectory(icons)
add_subdirectory(applications)
add_subdirectory(views)
add_subdirectory(accounts)
add_subdirectory(tests)
if (${ENABLE_EXTENSIONS})
    add_subdirectory(extensions)
endif()
include(ECMPoQmTools)

=== components/CMakeLists.txt ===
project(kube-components)

find_package(Qt5 REQUIRED NO_MODULE COMPONENTS Core Quick Test Gui Widgets)

macro(install_qml_component name)
    install(DIRECTORY ${name}/qml/ DESTINATION ${QML_INSTALL_DIR}/org/kube/components/${name})
    install(FILES ${name}/qmldir DESTINATION ${QML_INSTALL_DIR}/org/kube/components/${name})
endmacro(install_qml_component)

install_qml_component(kube)
add_subdirectory(kube/tests)
install_qml_component(accounts)


#Convert list to comma-separated and quoted list.
set(_AVAILABLE_ACCOUNT_PLUGINS ${AVAILABLE_ACCOUNT_PLUGINS})
set(AVAILABLE_ACCOUNT_PLUGINS "")
foreach(PLUGIN ${_AVAILABLE_ACCOUNT_PLUGINS})
    set(AVAILABLE_ACCOUNT_PLUGINS "${AVAILABLE_ACCOUNT_PLUGINS}, \"${PLUGIN}\"")
endforeach()
string(SUBSTRING "${AVAILABLE_ACCOUNT_PLUGINS}" 2 -1 AVAILABLE_ACCOUNT_PLUGINS)

configure_file(accounts/AccountConfiguration.qml.in accounts/AccountConfiguration.qml)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/accounts/AccountConfiguration.qml DESTINATION ${QML_INSTALL_DIR}/org/kube/components/accounts)

=== docker/Makefile ===
SOURCEDIR=~/kdebuild/kube/source
BUILDDIR=~/kdebuild/kube/build
INSTALLDIR=~/kdebuild/kube/install
NAME=kubedev

build:
	docker build -t ${NAME} .

rebuild:
	docker build --no-cache -t ${NAME} .

run:
	docker run --rm -ti --privileged -u developer --security-opt seccomp:unconfined -v /tmp/.docker.xauth:/tmp/.docker.xauth -v /tmp/.X11-unix:/tmp/.X11-unix --device /dev/dri/card0:/dev/dri/card0 -e DISPLAY=:0 -e XAUTHORITY=/tmp/.docker.xauth -v ${SOURCEDIR}:/src -v ${BUILDDIR}:/build -v ${INSTALLDIR}:/install -w /build/ ${NAME} '/bin/bash'

=== views/CMakeLists.txt ===
macro(install_view name)
    install(DIRECTORY ${name}/qml/ DESTINATION ${QML_INSTALL_DIR}/org/kube/views/${name})
    install(FILES ${name}/metadata.json DESTINATION ${QML_INSTALL_DIR}/org/kube/views/${name})
    add_test(NAME viewtest-${name} COMMAND kubetestrunner WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${name}/tests)
endmacro()

install_view(composer)
install_view(conversation)
install_view(people)
install_view(log)
install_view(accounts)
install_view(calendar)
install_view(todo)
if (${EXPERIMENTAL_VIEWS})
    # install_view(inboxcrusher)
    install_view(search)
endif()

=== applications/kube/CMakeLists.txt ===
include(ECMAddAppIcon)

find_package(Qt5 REQUIRED NO_MODULE COMPONENTS Quick DBus)

# install executable
set(SRCS main.cpp backtrace.cpp dbusinterface.cpp)

if(APPLE OR WIN32)
    # Sets the icon on Windows and OSX
    file(GLOB ICONS_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/../../icons/*-apps-kube_icon.png")
    ecm_add_app_icon(SRCS ICONS ${ICONS_SRCS})
endif()

add_executable(${PROJECT_NAME} ${SRCS})
set_target_properties(${PROJECT_NAME} PROPERTIES
    MACOSX_BUNDLE_INFO_PLIST MacOSXBundleInfo.plist.in
    MACOSX_BUNDLE_INFO_STRING "A modern communication and collaboration client."
    #MACOSX_BUNDLE_ICON_FILE already set by ecm_add_app_icon
    MACOSX_BUNDLE_GUI_IDENTIFIER "com.kubeproject.kube"
    MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION}
    MACOSX_BUNDLE_BUNDLE_NAME "Kube"
    MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION}
    MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
    MACOSX_BUNDLE_COPYRIGHT "Free and open-source under the GPL"
    )

target_link_libraries(${PROJECT_NAME}
    Qt5::Quick
    Qt5::DBus
    ${CMAKE_DL_LIBS}
    kubeframework
)

install(TARGETS ${PROJECT_NAME} DESTINATION ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

set(KUBE_APPLICATION_ID "org.kde.kube" CACHE STRING "The application identifier used for desktopfile and appdata")

set(KUBE_DESKTOPFILE_NAME "Kube" CACHE STRING "desktopfile name property")
set(KUBE_DESKTOPFILE_GENERICNAME "Mail Client" CACHE STRING "desktopfile genericname property")
set(KUBE_DESKTOPFILE_EXEC "kube" CACHE STRING "desktopfile exec property")
set(KUBE_DESKTOPFILE_COMMENT "Send, receive and manage your mail with Kube" CACHE STRING "desktopfile comment property")
set(KUBE_DESKTOPFILE_CATEGORIES "Qt;KDE;Office;Network;Email;" CACHE STRING "desktopfile categories property")
set(KUBE_DESKTOPFILENAME "${KUBE_APPLICATION_ID}.desktop")
configure_file(kube.desktop.in ${KUBE_DESKTOPFILENAME})
install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${KUBE_DESKTOPFILENAME} DESTINATION ${KDE_INSTALL_APPDIR} )

set(KUBE_APPDATA_ID "${KUBE_DESKTOPFILENAME}" CACHE STRING "appdata homepage property")
set(KUBE_APPDATA_HOMEPAGE "https://kube-project.com" CACHE STRING "appdata homepage property")
set(KUBE_APPDATA_BUGTRACKER "https://phabricator.kde.org/project/view/238/" CACHE STRING "appdata bugtracker property")
set(KUBE_APPDATA_HELP "https://kube.readthedocs.io/en/latest/" CACHE STRING "appdata help property")
set(KUBE_APPDATA_PROJECTGROUP "KDE" CACHE STRING "appdata projectgroup property")
set(KUBE_APPDATAFILENAME "${KUBE_APPLICATION_ID}.appdata.xml")
configure_file(kube.appdata.xml.in ${KUBE_APPDATAFILENAME})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${KUBE_APPDATAFILENAME} DESTINATION ${KDE_INSTALL_DATAROOTDIR}/appdata/)

=== framework/src/CMakeLists.txt ===

find_package(Qt5 COMPONENTS REQUIRED Core Concurrent Quick Qml WebEngineWidgets Test WebEngine Gui)
find_package(KF5Mime 4.87.0 CONFIG REQUIRED)
find_package(KF5CalendarCore 5.12.2 CONFIG REQUIRED)
find_package(Sink 0.9.0 CONFIG REQUIRED)
find_package(KAsync CONFIG REQUIRED)
find_package(Gpgme REQUIRED)
find_package(KF5Codecs CONFIG REQUIRED)
find_package(KF5Contacts CONFIG REQUIRED)
find_package(KF5Sonnet CONFIG REQUIRED)

include(GenerateExportHeader)

set(CMAKE_CXX_VISIBILITY_PRESET default)

include_directories(. domain/mime/mimetreeparser domain/ domain/mime)

add_library(kubeframework SHARED
    settings/settings.cpp
    domain/maillistmodel.cpp
    domain/folderlistmodel.cpp
    domain/perioddayeventmodel.cpp
    domain/eventoccurrencemodel.cpp
    domain/eventcontroller.cpp
    domain/invitationcontroller.cpp
    domain/todomodel.cpp
    domain/todocontroller.cpp
    domain/multidayeventmodel.cpp
    domain/composercontroller.cpp
    domain/modeltest.cpp
    domain/retriever.cpp
    domain/outboxmodel.cpp
    domain/identitiesmodel.cpp
    domain/recepientautocompletionmodel.cpp
    domain/settings/accountsettings.cpp
    domain/selector.cpp
    domain/completer.cpp
    domain/mouseproxy.cpp
    domain/contactcontroller.cpp
    domain/controller.cpp
    domain/peoplemodel.cpp
    domain/textdocumenthandler.cpp
    domain/spellcheckhighlighter.cpp
    domain/sinkutils.cpp
    domain/mime/htmlutils.cpp
    domain/mime/messageparser.cpp
    domain/mime/attachmentmodel.cpp
    domain/mime/partmodel.cpp
    domain/mime/mailtemplates.cpp
    accounts/accountfactory.cpp
    accounts/accountsmodel.cpp
    fabric.cpp
    sinkfabric.cpp
    kubeimage.cpp
    clipboardproxy.cpp
    krecursivefilterproxymodel.cpp
    qquicktreemodeladaptor.cpp
    startupcheck.cpp
    keyring.cpp
    domainobjectcontroller.cpp
    extensionmodel.cpp
    syntaxhighlighter.cpp
    viewhighlighter.cpp
    file.cpp
    logmodel.cpp
    entitymodel.cpp
    entitycontroller.cpp
    )
generate_export_header(kubeframework BASE_NAME Kube EXPORT_FILE_NAME kube_export.h)
set_target_properties(kubeframework PROPERTIES
    ENABLE_EXPORTS 1
    WINDOWS_EXPORT_ALL_SYMBOLS 1
)
target_link_libraries(kubeframework
    sink
    mailcrypto
    Qt5::Core
    Qt5::Quick
    Qt5::Qml
    Qt5::WebEngineWidgets
    Qt5::Test
    Qt5::WebEngine
    Qt5::Gui
    KF5::Codecs
    KF5::Contacts
    KF5::CalendarCore
    KF5::SonnetCore
    KAsync
)
install(TARGETS kubeframework DESTINATION ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

add_library(frameworkplugin SHARED frameworkplugin.cpp)
target_link_libraries(frameworkplugin
    kubeframework
)
install(TARGETS frameworkplugin DESTINATION ${FRAMEWORK_INSTALL_DIR})

set(BUILD_TESTING ON)

add_subdirectory(tests)
add_subdirectory(domain/mime)
add_subdirectory(domain/mime/tests)
add_subdirectory(domain/settings/tests)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== framework/qml/tests/CMakeLists.txt ===
add_test(NAME frameworkqmltests COMMAND kubetestrunner WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

=== framework/src/tests/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/..
)

find_package(Qt5 REQUIRED NO_MODULE COMPONENTS Core Test Gui)

macro(auto_tests)
    foreach(_testname ${ARGN})
        add_executable(${_testname} ${_testname}.cpp)
        add_test(${_testname} ${_testname})
        target_link_libraries(${_testname}
            Qt5::Core
            Qt5::Test
            Qt5::Gui
            kubeframework
        )
    endforeach(_testname)
endmacro(auto_tests)

auto_tests(
    folderlistmodeltest
    maillistmodeltest
    eventoccurrencemodeltest
    entitymodeltest
    entitycontrollertest
    invitationcontrollertest
    partmodeltest
)

=== framework/src/domain/mime/CMakeLists.txt ===
include_directories(${GPGME_INCLUDE_DIRS})
add_library(mailcrypto STATIC
    mailcrypto.cpp
)
target_link_libraries(mailcrypto
    PUBLIC
    Qt5::Core
    KF5::Mime
    Gpgme::Gpgme
    sink
)

=== PKGBUILD ===
# Maintainer: Antonio Rojas <arojas@archlinux.org>

pkgname=kube
pkgver=0.9.0
pkgrel=2
pkgdesc='A modern groupware client based on QtQuick and Sink'
arch=(x86_64)
url='https://kube.kde.org/'
license=(LGPL)
depends=(sink gpgme sonnet qt5-quickcontrols2 qt5-webengine qt5-quickcontrols)
makedepends=(extra-cmake-modules)
#source=(https://download.kde.org/unstable/$pkgname/$pkgver/src/$pkgname-$pkgver.tar.xz)
source=(https://invent.kde.org/pim/$pkgname/-/archive/v$pkgver/$pkgname-v$pkgver.tar.gz)
sha256sums=('75e6c0d1b04328eb2ada0ceea656753aa1a94361b94feaf81003733470400a63')

prepare() {
  sed -e 's|CMAKE_CXX_STANDARD 20|CMAKE_CXX_STANDARD 17|' -i $pkgname-v$pkgver/CMakeLists.txt # Fix build
  find . -name CMakeLists.txt | xargs sed -e '/tests/d' -i # Don't build tests
}

build() {
  cmake -B build -S $pkgname-v$pkgver \
    -DBUILD_TESTING=OFF
  cmake --build build
}

package() {
  DESTDIR="$pkgdir" cmake --install build
}
